// Copyright 2002 by SAS Institute Inc.
using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Xml;
using System.IO;

namespace EGUpdateAddIn
{
	/// <summary>
	/// This form is called by the UpdateTask class to dispaly a GUI to the user
	/// so that they can customize the actions of this task.
	/// </summary>
	internal class UpdateForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdOK;
		private System.Windows.Forms.Button cmdSave;
		private System.Windows.Forms.Button cmdCancel;
		private System.Windows.Forms.ListBox lstCols;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label lblLabel;
		private System.Windows.Forms.Label lblFormat;
		private System.Windows.Forms.Label lblType;
		private System.Windows.Forms.Label lblMissing;
		private System.Windows.Forms.Button cmdSelect;
		private System.Windows.Forms.Button cmdRemove;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label lblSelCol;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.RadioButton optCurrent;
		private System.Windows.Forms.RadioButton optMissing;
		private System.Windows.Forms.TextBox txtElseValue;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Button cmdAdd;
		private System.Windows.Forms.Button cmdDel;
		private System.Windows.Forms.TextBox txtReplace;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.TextBox txtWith;
		private System.Windows.Forms.ListView lstReplace;
		private System.Windows.Forms.RadioButton optSpecified;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UpdateForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			strColname = "";
			eElse = ElseSetting.CurrentValue;			
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{			
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdOK = new System.Windows.Forms.Button();
			this.cmdSave = new System.Windows.Forms.Button();
			this.cmdCancel = new System.Windows.Forms.Button();
			this.lstCols = new System.Windows.Forms.ListBox();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.lblMissing = new System.Windows.Forms.Label();
			this.lblType = new System.Windows.Forms.Label();
			this.lblFormat = new System.Windows.Forms.Label();
			this.lblLabel = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.cmdSelect = new System.Windows.Forms.Button();
			this.cmdRemove = new System.Windows.Forms.Button();
			this.label6 = new System.Windows.Forms.Label();
			this.lblSelCol = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.txtElseValue = new System.Windows.Forms.TextBox();
			this.optSpecified = new System.Windows.Forms.RadioButton();
			this.optMissing = new System.Windows.Forms.RadioButton();
			this.optCurrent = new System.Windows.Forms.RadioButton();
			this.label7 = new System.Windows.Forms.Label();
			this.cmdAdd = new System.Windows.Forms.Button();
			this.cmdDel = new System.Windows.Forms.Button();
			this.txtReplace = new System.Windows.Forms.TextBox();
			this.label8 = new System.Windows.Forms.Label();
			this.txtWith = new System.Windows.Forms.TextBox();
			this.lstReplace = new System.Windows.Forms.ListView();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// cmdOK
			// 
			this.cmdOK.Location = new System.Drawing.Point(32, 456);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.Size = new System.Drawing.Size(96, 32);
			this.cmdOK.TabIndex = 0;
			this.cmdOK.Text = "Save and Run";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// cmdSave
			// 
			this.cmdSave.Enabled = false;
			this.cmdSave.Location = new System.Drawing.Point(152, 456);
			this.cmdSave.Name = "cmdSave";
			this.cmdSave.Size = new System.Drawing.Size(96, 32);
			this.cmdSave.TabIndex = 1;
			this.cmdSave.Text = "Save";
			this.cmdSave.Click += new System.EventHandler(this.cmdSave_Click);
			// 
			// cmdCancel
			// 
			this.cmdCancel.Location = new System.Drawing.Point(272, 456);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.Size = new System.Drawing.Size(96, 32);
			this.cmdCancel.TabIndex = 2;
			this.cmdCancel.Text = "Cancel";
			this.cmdCancel.Click += new System.EventHandler(this.cmdCancel_Click);
			// 
			// lstCols
			// 
			this.lstCols.Location = new System.Drawing.Point(8, 24);
			this.lstCols.Name = "lstCols";
			this.lstCols.Size = new System.Drawing.Size(192, 108);
			this.lstCols.TabIndex = 3;
			this.lstCols.SelectedIndexChanged += new System.EventHandler(this.lstCols_SelectedIndexChanged);
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(98, 13);
			this.label1.TabIndex = 4;
			this.label1.Text = "Available Columns";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.lblMissing,
																					this.lblType,
																					this.lblFormat,
																					this.lblLabel,
																					this.label5,
																					this.label4,
																					this.label3,
																					this.label2});
			this.groupBox1.Location = new System.Drawing.Point(216, 24);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(200, 112);
			this.groupBox1.TabIndex = 5;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Column Information";
			// 
			// lblMissing
			// 
			this.lblMissing.AutoSize = true;
			this.lblMissing.Location = new System.Drawing.Point(104, 88);
			this.lblMissing.Name = "lblMissing";
			this.lblMissing.Size = new System.Drawing.Size(23, 13);
			this.lblMissing.TabIndex = 7;
			this.lblMissing.Text = "-----";
			// 
			// lblType
			// 
			this.lblType.AutoSize = true;
			this.lblType.Location = new System.Drawing.Point(104, 64);
			this.lblType.Name = "lblType";
			this.lblType.Size = new System.Drawing.Size(23, 13);
			this.lblType.TabIndex = 6;
			this.lblType.Text = "-----";
			// 
			// lblFormat
			// 
			this.lblFormat.AutoSize = true;
			this.lblFormat.Location = new System.Drawing.Point(104, 48);
			this.lblFormat.Name = "lblFormat";
			this.lblFormat.Size = new System.Drawing.Size(23, 13);
			this.lblFormat.TabIndex = 5;
			this.lblFormat.Text = "-----";
			// 
			// lblLabel
			// 
			this.lblLabel.AutoSize = true;
			this.lblLabel.Location = new System.Drawing.Point(104, 24);
			this.lblLabel.Name = "lblLabel";
			this.lblLabel.Size = new System.Drawing.Size(23, 13);
			this.lblLabel.TabIndex = 4;
			this.lblLabel.Text = "-----";
			// 
			// label5
			// 
			this.label5.AutoSize = true;
			this.label5.Location = new System.Drawing.Point(8, 87);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(92, 13);
			this.label5.TabIndex = 3;
			this.label5.Text = "Missing Allowed?";
			// 
			// label4
			// 
			this.label4.AutoSize = true;
			this.label4.Location = new System.Drawing.Point(8, 66);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(29, 13);
			this.label4.TabIndex = 2;
			this.label4.Text = "Type";
			// 
			// label3
			// 
			this.label3.AutoSize = true;
			this.label3.Location = new System.Drawing.Point(8, 45);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 13);
			this.label3.TabIndex = 1;
			this.label3.Text = "Format";
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(8, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(32, 13);
			this.label2.TabIndex = 0;
			this.label2.Text = "Label";
			// 
			// cmdSelect
			// 
			this.cmdSelect.Location = new System.Drawing.Point(24, 144);
			this.cmdSelect.Name = "cmdSelect";
			this.cmdSelect.Size = new System.Drawing.Size(56, 24);
			this.cmdSelect.TabIndex = 6;
			this.cmdSelect.Text = "Select";
			this.cmdSelect.Click += new System.EventHandler(this.cmdSelect_Click);
			// 
			// cmdRemove
			// 
			this.cmdRemove.Location = new System.Drawing.Point(96, 144);
			this.cmdRemove.Name = "cmdRemove";
			this.cmdRemove.Size = new System.Drawing.Size(56, 24);
			this.cmdRemove.TabIndex = 7;
			this.cmdRemove.Text = "Remove";
			this.cmdRemove.Click += new System.EventHandler(this.cmdRemove_Click);
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 176);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(96, 16);
			this.label6.TabIndex = 8;
			this.label6.Text = "Selected Column";
			// 
			// lblSelCol
			// 
			this.lblSelCol.Location = new System.Drawing.Point(112, 176);
			this.lblSelCol.Name = "lblSelCol";
			this.lblSelCol.Size = new System.Drawing.Size(184, 16);
			this.lblSelCol.TabIndex = 9;
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.txtElseValue,
																					this.optSpecified,
																					this.optMissing,
																					this.optCurrent});
			this.groupBox2.Location = new System.Drawing.Point(256, 304);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(160, 128);
			this.groupBox2.TabIndex = 10;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Replace All Others With";
			// 
			// txtElseValue
			// 
			this.txtElseValue.Enabled = false;
			this.txtElseValue.Location = new System.Drawing.Point(8, 96);
			this.txtElseValue.Name = "txtElseValue";
			this.txtElseValue.Size = new System.Drawing.Size(144, 20);
			this.txtElseValue.TabIndex = 3;
			this.txtElseValue.Text = "";
			// 
			// optSpecified
			// 
			this.optSpecified.Location = new System.Drawing.Point(8, 72);
			this.optSpecified.Name = "optSpecified";
			this.optSpecified.Size = new System.Drawing.Size(144, 16);
			this.optSpecified.TabIndex = 2;
			this.optSpecified.Text = "Specified Value";
			this.optSpecified.CheckedChanged += new System.EventHandler(this.optSpecified_CheckedChanged);
			// 
			// optMissing
			// 
			this.optMissing.Location = new System.Drawing.Point(8, 48);
			this.optMissing.Name = "optMissing";
			this.optMissing.Size = new System.Drawing.Size(144, 16);
			this.optMissing.TabIndex = 1;
			this.optMissing.Text = "Missing";
			this.optMissing.CheckedChanged += new System.EventHandler(this.optMissing_CheckedChanged);
			// 
			// optCurrent
			// 
			this.optCurrent.Checked = true;
			this.optCurrent.Location = new System.Drawing.Point(8, 24);
			this.optCurrent.Name = "optCurrent";
			this.optCurrent.Size = new System.Drawing.Size(144, 16);
			this.optCurrent.TabIndex = 0;
			this.optCurrent.TabStop = true;
			this.optCurrent.Text = "Current Value";
			this.optCurrent.CheckedChanged += new System.EventHandler(this.optCurrent_CheckedChanged);
			// 
			// label7
			// 
			this.label7.AutoSize = true;
			this.label7.Location = new System.Drawing.Point(8, 208);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(46, 13);
			this.label7.TabIndex = 12;
			this.label7.Text = "Replace";
			// 
			// cmdAdd
			// 
			this.cmdAdd.Location = new System.Drawing.Point(48, 272);
			this.cmdAdd.Name = "cmdAdd";
			this.cmdAdd.Size = new System.Drawing.Size(56, 24);
			this.cmdAdd.TabIndex = 13;
			this.cmdAdd.Text = "Add";
			this.cmdAdd.Click += new System.EventHandler(this.cmdAdd_Click);
			// 
			// cmdDel
			// 
			this.cmdDel.Location = new System.Drawing.Point(128, 272);
			this.cmdDel.Name = "cmdDel";
			this.cmdDel.Size = new System.Drawing.Size(56, 24);
			this.cmdDel.TabIndex = 14;
			this.cmdDel.Text = "Delete";
			this.cmdDel.Click += new System.EventHandler(this.cmdDel_Click);
			// 
			// txtReplace
			// 
			this.txtReplace.Location = new System.Drawing.Point(88, 208);
			this.txtReplace.Name = "txtReplace";
			this.txtReplace.Size = new System.Drawing.Size(144, 20);
			this.txtReplace.TabIndex = 15;
			this.txtReplace.Text = "";
			// 
			// label8
			// 
			this.label8.AutoSize = true;
			this.label8.Location = new System.Drawing.Point(8, 240);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(27, 13);
			this.label8.TabIndex = 16;
			this.label8.Text = "With";
			// 
			// txtWith
			// 
			this.txtWith.Location = new System.Drawing.Point(88, 236);
			this.txtWith.Name = "txtWith";
			this.txtWith.Size = new System.Drawing.Size(144, 20);
			this.txtWith.TabIndex = 17;
			this.txtWith.Text = "";
			// 
			// lstReplace
			// 
			this.lstReplace.Location = new System.Drawing.Point(8, 304);
			this.lstReplace.Name = "lstReplace";
			this.lstReplace.Size = new System.Drawing.Size(240, 128);
			this.lstReplace.TabIndex = 18;
			this.lstReplace.View = System.Windows.Forms.View.Details;
			this.lstReplace.SelectedIndexChanged += new System.EventHandler(this.lstReplace_SelectedIndexChanged);
			// 
			// UpdateForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(422, 492);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lstReplace,
																		  this.txtWith,
																		  this.label8,
																		  this.txtReplace,
																		  this.cmdDel,
																		  this.cmdAdd,
																		  this.label7,
																		  this.groupBox2,
																		  this.lblSelCol,
																		  this.label6,
																		  this.cmdRemove,
																		  this.cmdSelect,
																		  this.groupBox1,
																		  this.label1,
																		  this.lstCols,
																		  this.cmdCancel,
																		  this.cmdSave,
																		  this.cmdOK});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Name = "UpdateForm";
			this.Text = "Update Dataset Column Task";
			this.Load += new System.EventHandler(this.UpdateForm_Load);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		

		//this is the button the user clicked to dismiss the dialog
		private SASAIOBJLib.APPSHOWSTATUS status;
		public int Status
		{
			get
			{
				return ( int ) status;
			}
		}

		//this is the code that was generated based on the users settings
		private string code;
		public string Code
		{
			get
			{
				return code;
			}
		}

		//the input dataset
		private SASAIOBJLib.SEGData data;
		public SASAIOBJLib.SEGData Data
		{
			set
			{
				this.data = value;
			}
		}

		//the column to be acted on
		private SASAIOBJLib.SEGColumnInfo selectedColumn;
		private string strColname;
		public string strColumnName
		{
			get
			{
				if ( selectedColumn != null )
				{
					strColname = selectedColumn.VariableName;
				}
				return strColname;
			}
			set
			{
				strColname = value;
			}
		}

		//what to do in the case that a row's value does not match
		//any of the conditions in the replace list
		public string strElseValue
		{
			get
			{
				string rc = "";
				if ( eElse == ElseSetting.SpecifiedValue )
					rc = txtElseValue.Text;

				return rc;
			}
			set
			{
				txtElseValue.Text = value;
			}
		}
		public EGUpdateAddIn.ElseSetting eElse;
		
		//the list in XML form of the users choices of what to replace
		//in the dataset
		public string ReplaceList
		{
			get
			{
				string list = "";
				int numItems = lstReplace.Items.Count;
				if ( numItems > 0 )
				{				
					try
					{
						string strTagWith = "With";
						string strTagValue = "Value";
						System.IO.MemoryStream ms = new MemoryStream(500);
						XmlTextWriter xWriter = new XmlTextWriter(ms, System.Text.Encoding.UTF8 );
						xWriter.WriteStartDocument();
						xWriter.WriteStartElement( "NumItems" );
						xWriter.WriteElementString( "Number", numItems.ToString() );
						for ( int i = 0; i < numItems; i ++ )
						{
							//get first elements
							string strValue = lstReplace.Items[i].Text;
							string strWith = lstReplace.Items[i].SubItems[1].Text;
							string strTagRep = string.Format("Replace{0}",i);
							xWriter.WriteStartElement(strTagRep);
							xWriter.WriteElementString( strTagValue, strValue );
							xWriter.WriteElementString( strTagWith, strWith );
							xWriter.WriteEndElement();
						}
						xWriter.WriteEndElement();
						xWriter.WriteEndDocument();
						xWriter.Flush();
						StreamReader sr = new StreamReader( ms );
						sr.BaseStream.Seek( 0, SeekOrigin.Begin );
						list = sr.ReadToEnd();
						xWriter.Close();
					}
					catch ( Exception ex )
					{
						MessageBox.Show( ex.Message );
					}
				}
				return list;
			}
			set
			{
				if ( value.Length > 0 )
				{
					try
					{
						string strTagWith = "With";
						string strTagValue = "Value";
						//parse incoming string and fill listview 
						StringReader s = new StringReader( value );
						XmlTextReader xReader = new XmlTextReader( s );
						//first read number of items
						xReader.ReadStartElement( "NumItems" );
						int numItems = Convert.ToInt32(xReader.ReadString());
						xReader.ReadEndElement();
						for ( int i = 0; i < numItems; i++ )
						{
							string strTagRep = string.Format("Replace{0}",i);
							xReader.ReadStartElement( strTagRep );
							string strValue = xReader.ReadElementString(strTagValue);
							string strWith = xReader.ReadElementString(strTagWith);
							xReader.ReadEndElement();
							lstReplace.Items.Add("");
							lstReplace.Items[i].SubItems[0].Text = strValue;
							lstReplace.Items[i].SubItems.Add( strWith );
						}
						xReader.ReadEndElement();
						xReader.Close();
					}
					catch ( Exception ex )
					{
						MessageBox.Show( ex.Message );
					}
				}
			}
		}

		//called when the form is loaded, setup the GUI controls to intial 
		//values or what was set by EG in the case that this is a saved task
		private void UpdateForm_Load(object sender, System.EventArgs e)
		{
			status = SASAIOBJLib.APPSHOWSTATUS.APP_SHOW_CANCELED;
			code = "";			
			lblSelCol.Text = "";
			int width = lstReplace.ClientRectangle.Width/2;
			lstReplace.Columns.Clear();
			lstReplace.Columns.Add( "Replace", width, HorizontalAlignment.Center );
			lstReplace.Columns.Add( "With", width, HorizontalAlignment.Center );
			lstReplace.MultiSelect = false;

			//fill replace listview with values from replace list
			
			//set up else setting
			switch ( this.eElse )
			{
				case EGUpdateAddIn.ElseSetting.CurrentValue:
					optCurrent.Checked = true;
					break;
				case EGUpdateAddIn.ElseSetting.Missing:
					optMissing.Checked = true;
					break;
				case EGUpdateAddIn.ElseSetting.SpecifiedValue:
					optSpecified.Checked = true;
					txtElseValue.Enabled = true;
					break;
			}

			if ( data != null )
			{
				try
				{
					//get list of columns
					SASAIOBJLib.SEGAccessor Acc = data.GetAccessor();
					int numColumns = Acc.Columns;
					for ( int i = 0; i < numColumns; i++ )
					{
						SASAIOBJLib.SEGColumnInfo ColInfo = Acc.GetColumnInfoItem( i );
						string strName = ColInfo.VariableName;
						lstCols.Items.Add( strName );
						if ( strName.Equals( strColname ) )
						{
							lstCols.SelectedIndex = i;
							selectedColumn = ColInfo;
							lblSelCol.Text = strColname;
						}
					}
					if ( lstCols.SelectedIndex == - 1)
						lstCols.SelectedIndex = 0;
				}
				catch( Exception Ex )
				{
					MessageBox.Show( Ex.Message );
				}
			}

			UpdateGUI();
		}

		protected override void OnPaint(System.Windows.Forms.PaintEventArgs e)
		{
			Graphics grfx = e.Graphics;
			Pen pen = new Pen( SystemColors.WindowText, 2 );
			
			int StartHeight = cmdOK.Top - 10;
			grfx.DrawLine( pen, 0, StartHeight, ClientSize.Width, StartHeight );

		}

		//if the user selects a different column to update
		private void lstCols_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				int index = lstCols.SelectedIndex;
				if ( index >= 0 )
				{
					string strGroup;
					SASAIOBJLib.SEGAccessor Acc = data.GetAccessor();
					SASAIOBJLib.SEGColumnInfo ColInfo = Acc.GetColumnInfoItem( index );
					SASAIOBJLib.APPVARGROUP group = (SASAIOBJLib.APPVARGROUP)ColInfo.VariableGroup;
					switch ( group )
					{
						case SASAIOBJLib.APPVARGROUP.APP_VARGROUP_NUMERIC:
							strGroup = "Numeric";
							break;
						case SASAIOBJLib.APPVARGROUP.APP_VARGROUP_DATE:
							strGroup = "Date";
							break;
						case SASAIOBJLib.APPVARGROUP.APP_VARGROUP_CURRENCY:
							strGroup = "Currency";
							break;
						case SASAIOBJLib.APPVARGROUP.APP_VARGROUP_TIME:
							strGroup = "Time";
							break;
						case SASAIOBJLib.APPVARGROUP.APP_VARGROUP_CHARACTER:
							strGroup = "Character";
							break;
						default:
							strGroup = "Unknown";
							break;
					}
					lblLabel.Text = ColInfo.DisplayName;
					lblFormat.Text = ColInfo.Format;
					lblType.Text = strGroup;
					lblMissing.Text = ColInfo.MissingAllowed.ToString();
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show( ex.Message );
			}
			UpdateGUI();
		}

		//this selects the column that the user has chosen
		private void cmdSelect_Click(object sender, System.EventArgs e)
		{
			int index = lstCols.SelectedIndex;
			SASAIOBJLib.SEGAccessor Acc = data.GetAccessor();
			selectedColumn = Acc.GetColumnInfoItem( index );
			lblSelCol.Text = selectedColumn.VariableName;
			UpdateGUI();
		}

		//this will deselect the chosen column
		private void cmdRemove_Click(object sender, System.EventArgs e)
		{
			if ( selectedColumn != null )
			{
				selectedColumn = null;
				lblSelCol.Text = "";
			}

			lstReplace.Items.Clear();
			UpdateGUI();
		}

		//this will add a condition to the replace list
		private void cmdAdd_Click(object sender, System.EventArgs e)
		{
			try
			{
				int curIndex = lstReplace.Items.Count;
				lstReplace.Items.Add( "" );
				lstReplace.Items[curIndex].SubItems[0].Text = txtReplace.Text;
				lstReplace.Items[curIndex].SubItems.Add( txtWith.Text );
			}
			catch( Exception ex )
			{
				MessageBox.Show( ex.Message );
			}
			UpdateGUI();
		}

		//this will delete a condition from the replace list
		private void cmdDel_Click(object sender, System.EventArgs e)
		{
			if ( lstReplace.SelectedIndices.Count >= 0 )
			{
				lstReplace.Items.RemoveAt( lstReplace.SelectedIndices[0] );			
				UpdateGUI();
			}
		}

		//this is called to update the GUI controls based on the current settings
		private void UpdateGUI()
		{
			if ( selectedColumn == null )
			{
				cmdRemove.Enabled = false;
				cmdSelect.Enabled = true;
			}
			else
			{
				cmdRemove.Enabled = true;
				cmdSelect.Enabled = false;
			}

			if ( lblSelCol.Text.Length > 0 ) 
				cmdAdd.Enabled = true;	
			else
				cmdAdd.Enabled = false;

			if ( lstReplace.SelectedIndices.Count > 0 )
				cmdDel.Enabled = true;
			else
				cmdDel.Enabled = false;
		}

		private void lstReplace_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			UpdateGUI();
		}

		//user has decided that these settings are what they want
		private void cmdOK_Click(object sender, System.EventArgs e)
		{
			status = SASAIOBJLib.APPSHOWSTATUS.APP_SHOW_RUNNOW;
			SetupCode();
			this.Close();
		}

		//this status option has not been implemented by EG as of version 2.0,
		//but if it were it would save the task, without running it.
		private void cmdSave_Click(object sender, System.EventArgs e)
		{
			
			status = SASAIOBJLib.APPSHOWSTATUS.APP_SHOW_RUNLATER;
			SetupCode();
			this.Close();
		}

		//user does not wish to create or modify this task
		private void cmdCancel_Click(object sender, System.EventArgs e)
		{
			status = SASAIOBJLib.APPSHOWSTATUS.APP_SHOW_CANCELED;
			this.Close();
		}

		//this takes the settings of the user and creates the proc sql code that
		//will be submitted to the server when the user asks to run this task
		private void SetupCode()
		{ 
			try
			{				
				string libref = data.Libref;
				string member = data.Member;
				string strColName = selectedColumn.VariableName;
				//for chacter columns, values need to be in quotes
				string strQuote = "";
				if ( selectedColumn.VariableGroup == (int)SASAIOBJLib.APPVARGROUP.APP_VARGROUP_CHARACTER )
					strQuote = "'";

				string strElse;
				if ( optMissing.Checked )
					strElse = "";
				else if ( optSpecified.Checked ) 
					strElse = "else " + strQuote + txtElseValue.Text + strQuote;
				else
					strElse = "else " + ( member + "." + strColName );

				
				int count = lstReplace.Items.Count;

				code  = "Proc SQL UNDO_POLICY=OPTIONAL;\r\n\tUpdate ";
				code += ( libref + "." + member );
				code += "\r\n\t\tSet " + strColName + " = \r\n\t\t\tcase ";
				for ( int i = 0; i < count; i++ )
				{
					code += "when " + strColName + " = " + strQuote + lstReplace.Items[i].Text + strQuote;
					code += " then " + strQuote + lstReplace.Items[i].SubItems[1].Text + strQuote;
					code += "\r\n\t\t\t";
				}
				if ( strElse.Length > 0 )
				{
					code += strElse;
				}
				code += "\r\n\t\tend;\r\nselect * from ";
				code += ( libref + "." + member ) + ";";
			}
			catch( System.Exception e )
			{
				MessageBox.Show( e.Message );
			}

		}

		//else setting checkbox changed 
		private void optSpecified_CheckedChanged(object sender, System.EventArgs e)
		{
			if ( optSpecified.Checked == true )
			{
				txtElseValue.Enabled = true;
				eElse = ElseSetting.SpecifiedValue;
			}
			else
				txtElseValue.Enabled = false;
		}

		//else setting checkbox changed 
		private void optCurrent_CheckedChanged(object sender, System.EventArgs e)
		{
			if ( optCurrent.Checked )
				eElse = ElseSetting.CurrentValue;
		}

		//else setting checkbox changed 
		private void optMissing_CheckedChanged(object sender, System.EventArgs e)
		{
			if ( optMissing.Checked )
				eElse = ElseSetting.Missing;
		} 
	
	} 
}
